package hr.webtech.pay2.example;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Toast;

import java.util.Calendar;
import java.util.Random;

import ba.leftor.android.pikpay.BuildConfig;
import ba.leftor.android.pikpay.R;
import hr.webtech.pay2.api.PgwApi;
import hr.webtech.pay2.api.PgwModule;
import hr.webtech.pay2.data.DeletePaymentResponse;
import hr.webtech.pay2.data.UpdatePaymentResponse;
import rx.android.schedulers.AndroidSchedulers;
import rx.functions.Action1;
import rx.schedulers.Schedulers;

public final class PgwModuleExampleActivity extends AppCompatActivity {

    private PgwApi api;

    public static Intent createIntent(Context context) {
        return new Intent(context, PgwModuleExampleActivity.class);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_net_module_example);


        PgwModule pgwModule = new PgwModule("rIFgEitALWiVIZtfwoVSAwdVntnryfrw", BuildConfig.DEBUG);

        this.api = pgwModule.getApi();

        findViewById(R.id.delete_payment_method).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                deletePaymentMethod();
            }
        });

        findViewById(R.id.update_payment_method).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                updatePaymentMethod();
            }
        });
    }

    private void updatePaymentMethod() {
        Calendar calendar = Calendar.getInstance();

        Random r = new Random();

        calendar.set(Calendar.DAY_OF_MONTH, 1);
        calendar.set(Calendar.MONTH, r.nextInt(12));
        calendar.set(Calendar.YEAR, 2022);

        api.updatePaymentMethod("hDAw8j21UfRK7-TUG5DK1s_llOrHLzqabI2-Or8t", calendar.getTime())
                .subscribeOn(Schedulers.io())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(new Action1<UpdatePaymentResponse>() {
                    @Override
                    public void call(UpdatePaymentResponse updatePaymentResponse) {
                        if (updatePaymentResponse.succeded()) {
                            Toast.makeText(PgwModuleExampleActivity.this, "Payment method updated", Toast.LENGTH_LONG).show();
                        } else {
                            Toast.makeText(PgwModuleExampleActivity.this, String.format("Payment method update error %s", updatePaymentResponse.getErrorResponse().getMessage()), Toast.LENGTH_LONG).show();
                        }
                    }
                }, new Action1<Throwable>() {
                    @Override
                    public void call(Throwable throwable) {
                        Toast.makeText(PgwModuleExampleActivity.this, String.format("Payment method update error %s", throwable.getMessage()), Toast.LENGTH_LONG).show();
                    }
                });
    }

    private void deletePaymentMethod() {
        api.deletePaymentMethod("cxBrOFUsPIt4mqnmlIOFSqfdcYU9f4N7GEjtvBQ4", "User delete")
                .subscribeOn(Schedulers.io())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(new Action1<DeletePaymentResponse>() {
                    @Override
                    public void call(DeletePaymentResponse deletePaymentResponse) {
                        if (deletePaymentResponse.succeded()) {
                            Toast.makeText(PgwModuleExampleActivity.this, "Payment method deleted", Toast.LENGTH_LONG).show();
                        } else {
                            Toast.makeText(PgwModuleExampleActivity.this, String.format("Payment method delete error %s", deletePaymentResponse.getErrorResponse().getMessage()), Toast.LENGTH_LONG).show();
                        }
                    }
                }, new Action1<Throwable>() {
                    @Override
                    public void call(Throwable throwable) {
                        Toast.makeText(PgwModuleExampleActivity.this, String.format("Payment method delete error %s", throwable.getMessage()), Toast.LENGTH_LONG).show();
                    }
                });
    }


}
