package hr.webtech.pay2.example;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.widget.ListView;

import java.util.List;

import ba.leftor.android.pikpay.R;
import hr.webtech.pay2.data.Merchant;
import hr.webtech.pay2.example.data.MerchantProvider;
import rx.functions.Action1;

import static hr.webtech.pay2.example.WebtehWebViewExampleActivity.BNLD_ADD_PAYMENT_METHOD;
import static hr.webtech.pay2.example.WebtehWebViewExampleActivity.BNLD_PAY;
import static hr.webtech.pay2.example.WebtehWebViewExampleActivity.BNLD_PAY_WITH_PAYMENT_METHOD;

public class PickMerchantActivity extends Activity {

    private boolean payCvv;
    private boolean addPaymentMethodExample;
    private boolean payWithPaymentMethod;

    public static Intent createIntent(Context context, boolean payCvv) {
        final Intent intent = new Intent(context, PickMerchantActivity.class);
        intent.putExtra(BNLD_PAY, payCvv);
        return intent;
    }

    public static Intent createIntent(Context context, boolean payCvv, boolean addPaymentMethodExample) {
        final Intent intent = new Intent(context, PickMerchantActivity.class);
        intent.putExtra(BNLD_PAY, payCvv);
        intent.putExtra(BNLD_ADD_PAYMENT_METHOD, addPaymentMethodExample);
        return intent;
    }

    public static Intent payWithSavedCard(Context context) {
        final Intent intent = new Intent(context, PickMerchantActivity.class);
        intent.putExtra(BNLD_PAY, false);
        intent.putExtra(BNLD_ADD_PAYMENT_METHOD, false);
        intent.putExtra(BNLD_PAY_WITH_PAYMENT_METHOD, true);
        return intent;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_pick_merchant);
        final Intent intent = getIntent();
        this.payCvv = intent.getBooleanExtra(BNLD_PAY, false);
        this.addPaymentMethodExample = intent.getBooleanExtra(BNLD_ADD_PAYMENT_METHOD, false);
        this.payWithPaymentMethod = intent.getBooleanExtra(BNLD_PAY_WITH_PAYMENT_METHOD, false);

        final ListView listview = findViewById(R.id.listview);

        final List<Merchant> list = MerchantProvider.getAllMerchants();

        final StableArrayAdapter adapter = new MerchantAdapter(this,
                list, new Action1<Merchant>() {
            @Override
            public void call(Merchant merchant) {
                goToWebtehExample(merchant);
            }
        });
        listview.setAdapter(adapter);


    }

    void goToWebtehExample(Merchant merchant) {

        if (payCvv) {
            final Intent intent = PickPaymentMethodActivity.createIntent(this, merchant);
            startActivity(intent);
        } else if (addPaymentMethodExample) {
            final Intent intent = AddPaymentMethodActivity.createIntent(this, merchant);
            startActivity(intent);
        } else if (payWithPaymentMethod) {
            final Intent intent = PickPaymentMethodActivity.createIntent(this, merchant, true);
            startActivity(intent);
        } else {
            final Intent intent = WebtehWebViewExampleActivity.createIntent(this, getIntent().getBooleanExtra(BNLD_PAY, false), merchant);
            startActivity(intent);
        }

    }

}
