package hr.webtech.pay2.example;

import android.content.Context;
import android.widget.ArrayAdapter;

import java.util.List;

import rx.functions.Action1;

/**
 * Created by jasminsuljic on 03/08/2018.
 * pgw-android
 */
public class StableArrayAdapter<T> extends ArrayAdapter<T> {

    List<T> values;
    private final Action1<T> onClickAction;

    StableArrayAdapter(Context context,
                       List<T> objects,
                       Action1<T> onClickAction) {
        super(context, -1, objects);
        this.values = objects;
        this.onClickAction = onClickAction;
    }


    @Override
    public long getItemId(int position) {
        return position;
    }

    void setValues(List<T> values) {
        this.values.clear();
        this.values.addAll(values);

        notifyDataSetChanged();
    }

    @Override
    public boolean hasStableIds() {
        return true;
    }


    void onClick(T t) {
        this.onClickAction.call(t);
    }
}
