package hr.webtech.pay2.api;

import android.support.annotation.Nullable;

import com.google.gson.annotations.Expose;

import java.util.List;

/**
 * Created by jasminsuljic on 19/12/16.
 * pgw-android
 */
public final class ApiErrorException extends RetrofitException {

    @Expose
    private String error;

    @Expose
    @Nullable
    private List<String> errors;

    private ApiErrorException(String error, @Nullable List<String> errors) {
        super(error, Kind.API_ERROR_EXCEPTION, null);
        this.error = error;
        this.errors = errors;
    }

    @Override
    public String getMessage() {
        if (error == null) {
            if (errors != null) {
                StringBuilder stringBuilder = new StringBuilder();
                for (String s : errors) {
                    stringBuilder.append(s);
                    stringBuilder.append('\n');
                }
                error = stringBuilder.toString();
            } else {
                error = "Unknown error occured";
            }
        }
        return error;
    }

    @Override
    public String toString() {
        return "ApiErrorException{" + "error='" + error + '\'' +
                ", errors=" + errors +
                '}';
    }
}

