
package hr.webtech.pay2.data;
import android.support.annotation.NonNull;
// THIS CODE IS GENERATED!!
@SuppressWarnings({"ThrowableInstanceNeverThrown", "ThrowableResultOfMethodCallIgnored"})
public class ApiErrors{
    
  /**
   * description - Validation error
   * <p/>
   * message - %s
   */
  public static final int validationError = 200000;

  /**
   * description - Unknown business error
   * <p/>
   * message - Unknown business error
   */
  public static final int unknownBusinessError = 200001;

  /**
   * description - Validation error [DEPRECATED], use validationError
   * <p/>
   * message - %s
   */
  public static final int validationErrorCode = 200000;

  /**
   * description - Unknown business error - [DEPRECATED], use unknownBusinessError
   * <p/>
   * message - Unknown business error
   */
  public static final int unknownBusinessErrorCode = 200001;

  /**
   * description - Ipg validation failed
   * <p/>
   * message - Ipg validation failed
   */
  public static final int ipgValidationFailed = 200002;

  /**
   * description - Error for view not found when loading form [add-card, pay-cvv]
   * <p/>
   * message - View %s not found
   */
  public static final int viewNotFoundError = 200003;

  /**
   * description - Curl error when communicating with payment gateway
   * <p/>
   * message - Curl error
   */
  public static final int curlError = 200004;

  /**
   * description - Unknown api error
   * <p/>
   * message - Unknown api error
   */
  public static final int unknownApiError = 200005;

  /**
   * description - libraryNetworkError
   * <p/>
   * message - %s
   */
  public static final int libraryNetworkError = 200006;

  /**
   * description - libraryHttpError
   * <p/>
   * message - %s
   */
  public static final int libraryHttpError = 200007;

  /**
   * description - libraryUnexpectedError
   * <p/>
   * message - %s
   */
  public static final int libraryUnexpectedError = 200008;

  /**
   * description - libraryParsingError
   * <p/>
   * message - %s
   */
  public static final int libraryParsingError = 200009;

  /**
   * description - libraryUnknownError
   * <p/>
   * message - %s
   */
  public static final int libraryUnknownError = 200010;

  /**
   * description - libraryTimeoutError
   * <p/>
   * message - Timeout occurred after %d seconds
   */
  public static final int libraryTimeoutError = 200011;

  /**
   * description - Transaction not found on proxy
   * <p/>
   * message - Transaction with orderNumber %s not found!
   */
  public static final int transactionNotFoundProxy = 200012;

  /**
   * description - Transaction not found on payment gateway
   * <p/>
   * message - Transaction with orderNumber %s not found!
   */
  public static final int transactionNotFoundPgw = 200013;

  /**
   * description - Check order id validation failed
   * <p/>
   * message - Check order id validation failed
   */
  public static final int apiCheckOrderIdValidationFailed = 200014;

  /**
   * description - Term url validation failed. Required fields: [PaRes, MD]
   * <p/>
   * message - Term url validation failed
   */
  public static final int termUrlValidationFailed = 200015;

  /**
   * description - Not authorized, check do you provide auth token.
   * <p/>
   * message - Not authorized!
   */
  public static final int notAuthorized = 200016;

  /**
   * description - Not found, check url!
   * <p/>
   * message - Not found!
   */
  public static final int notFound = 200017;

  /**
   * description - Unknown http exception
   * <p/>
   * message - HttpException with statusCode: %d and message: %s
   */
  public static final int httpException = 200018;

  /**
   * description - Unresolved exception
   * <p/>
   * message - Unresolved exception with code: %d and message: %s
   */
  public static final int unresolvedException = 200019;

  /**
   * description - Transaction not found
   * <p/>
   * message - Transaction with id: %d not found
   */
  public static final int transactionNotFoundId = 200020;

  /**
   * description - Error log not found
   * <p/>
   * message - Error log with id: %d not found
   */
  public static final int errorLogNotFound = 200021;

  /**
   * description - Invalid input data
   * <p/>
   * message - Invalid input data
   */
  public static final int errorLogInvalidData = 200022;


    
  /**
   * description - Validation error
   * <p/>
   * message - %s
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError validationError(@NonNull Throwable cause){
    return new ApiError(validationError, true, cause);
  }

  /**
   * description - Unknown business error
   * <p/>
   * message - Unknown business error
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError unknownBusinessError(@NonNull Throwable cause){
    return new ApiError(unknownBusinessError, true, cause);
  }

  /**
   * description - Validation error [DEPRECATED], use validationError
   * <p/>
   * message - %s
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError validationErrorCode(@NonNull Throwable cause){
    return new ApiError(validationErrorCode, true, cause);
  }

  /**
   * description - Unknown business error - [DEPRECATED], use unknownBusinessError
   * <p/>
   * message - Unknown business error
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError unknownBusinessErrorCode(@NonNull Throwable cause){
    return new ApiError(unknownBusinessErrorCode, true, cause);
  }

  /**
   * description - Ipg validation failed
   * <p/>
   * message - Ipg validation failed
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError ipgValidationFailed(@NonNull Throwable cause){
    return new ApiError(ipgValidationFailed, true, cause);
  }

  /**
   * description - Error for view not found when loading form [add-card, pay-cvv]
   * <p/>
   * message - View %s not found
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError viewNotFoundError(@NonNull Throwable cause){
    return new ApiError(viewNotFoundError, true, cause);
  }

  /**
   * description - Curl error when communicating with payment gateway
   * <p/>
   * message - Curl error
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError curlError(@NonNull Throwable cause){
    return new ApiError(curlError, true, cause);
  }

  /**
   * description - Unknown api error
   * <p/>
   * message - Unknown api error
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError unknownApiError(@NonNull Throwable cause){
    return new ApiError(unknownApiError, true, cause);
  }

  /**
   * description - libraryNetworkError
   * <p/>
   * message - %s
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError libraryNetworkError(@NonNull Throwable cause){
    return new ApiError(libraryNetworkError, true, cause);
  }

  /**
   * description - libraryHttpError
   * <p/>
   * message - %s
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError libraryHttpError(@NonNull Throwable cause){
    return new ApiError(libraryHttpError, true, cause);
  }

  /**
   * description - libraryUnexpectedError
   * <p/>
   * message - %s
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError libraryUnexpectedError(@NonNull Throwable cause){
    return new ApiError(libraryUnexpectedError, true, cause);
  }

  /**
   * description - libraryParsingError
   * <p/>
   * message - %s
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError libraryParsingError(@NonNull Throwable cause){
    return new ApiError(libraryParsingError, true, cause);
  }

  /**
   * description - libraryUnknownError
   * <p/>
   * message - %s
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError libraryUnknownError(@NonNull Throwable cause){
    return new ApiError(libraryUnknownError, true, cause);
  }

  /**
   * description - libraryTimeoutError
   * <p/>
   * message - Timeout occurred after %d seconds
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError libraryTimeoutError(@NonNull Throwable cause){
    return new ApiError(libraryTimeoutError, true, cause);
  }

  /**
   * description - Transaction not found on proxy
   * <p/>
   * message - Transaction with orderNumber %s not found!
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError transactionNotFoundProxy(@NonNull Throwable cause){
    return new ApiError(transactionNotFoundProxy, true, cause);
  }

  /**
   * description - Transaction not found on payment gateway
   * <p/>
   * message - Transaction with orderNumber %s not found!
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError transactionNotFoundPgw(@NonNull Throwable cause){
    return new ApiError(transactionNotFoundPgw, true, cause);
  }

  /**
   * description - Check order id validation failed
   * <p/>
   * message - Check order id validation failed
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError apiCheckOrderIdValidationFailed(@NonNull Throwable cause){
    return new ApiError(apiCheckOrderIdValidationFailed, true, cause);
  }

  /**
   * description - Term url validation failed. Required fields: [PaRes, MD]
   * <p/>
   * message - Term url validation failed
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError termUrlValidationFailed(@NonNull Throwable cause){
    return new ApiError(termUrlValidationFailed, true, cause);
  }

  /**
   * description - Not authorized, check do you provide auth token.
   * <p/>
   * message - Not authorized!
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError notAuthorized(@NonNull Throwable cause){
    return new ApiError(notAuthorized, true, cause);
  }

  /**
   * description - Not found, check url!
   * <p/>
   * message - Not found!
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError notFound(@NonNull Throwable cause){
    return new ApiError(notFound, true, cause);
  }

  /**
   * description - Unknown http exception
   * <p/>
   * message - HttpException with statusCode: %d and message: %s
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError httpException(@NonNull Throwable cause){
    return new ApiError(httpException, true, cause);
  }

  /**
   * description - Unresolved exception
   * <p/>
   * message - Unresolved exception with code: %d and message: %s
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError unresolvedException(@NonNull Throwable cause){
    return new ApiError(unresolvedException, true, cause);
  }

  /**
   * description - Transaction not found
   * <p/>
   * message - Transaction with id: %d not found
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError transactionNotFoundId(@NonNull Throwable cause){
    return new ApiError(transactionNotFoundId, true, cause);
  }

  /**
   * description - Error log not found
   * <p/>
   * message - Error log with id: %d not found
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError errorLogNotFound(@NonNull Throwable cause){
    return new ApiError(errorLogNotFound, true, cause);
  }

  /**
   * description - Invalid input data
   * <p/>
   * message - Invalid input data
   *
   * @param cause throwable which caused exception
   * @return ApiError instance
   */
  @NonNull
  public static ApiError errorLogInvalidData(@NonNull Throwable cause){
    return new ApiError(errorLogInvalidData, true, cause);
  }

}