package hr.webtech.pay2.data;

import android.support.annotation.NonNull;
import android.support.annotation.Nullable;

import hr.webtech.pay2.util.Objects;

/**
 * Created by jasminsuljic on 01/08/2018.
 * pgw-android
 */
public class DeletePaymentResponse {

    @Nullable
    private DeletePaymentMethodSuccess successResponse;
    @Nullable
    private DeletePaymentMethodError errorResponse;

    private DeletePaymentResponse(@Nullable DeletePaymentMethodSuccess successResponse, @Nullable DeletePaymentMethodError errorResponse) {
        this.successResponse = successResponse;
        this.errorResponse = errorResponse;
    }

    public boolean succeded() {
        return successResponse != null;
    }

    public boolean failed() {
        return !succeded();
    }

    public static DeletePaymentResponse create(@NonNull DeletePaymentMethodSuccess successResponse) {
        return new DeletePaymentResponse(Objects.requireNonNull(successResponse, "successResponse == null"), null);
    }

    public static DeletePaymentResponse create(@NonNull DeletePaymentMethodError deletePaymentMethodError) {
        return new DeletePaymentResponse(null, Objects.requireNonNull(deletePaymentMethodError, "deletePaymentMethodError == null"));
    }

    @Nullable
    public DeletePaymentMethodSuccess getSuccessResponse() {
        return successResponse;
    }

    @Nullable
    public DeletePaymentMethodError getErrorResponse() {
        return errorResponse;
    }

}
