package hr.webtech.pay2.data;

import android.os.Parcel;
import android.os.Parcelable;

import com.google.gson.annotations.Expose;
import com.google.gson.annotations.SerializedName;

/**
 * Created by jasminsuljic on 01/08/2018.
 * pgw-android
 */
public class PaymentMethod implements Parcelable {

    @Expose
    @SerializedName("id")
    private String id;
    @Expose
    @SerializedName("name")
    private String name;
    @Expose
    @SerializedName("user_id")
    private String userId;
    @Expose
    @SerializedName("card_type")
    private String cardType;
    @Expose
    @SerializedName("masked_pan")
    private String maskedPan;
    @Expose
    @SerializedName("year")
    private String year;
    @Expose
    @SerializedName("month")
    private String month;
    @Expose
    @SerializedName("expires_soon")
    private boolean expiresSoon;

    @Expose
    @SerializedName("merchant_id")
    private String merchantId;

    public String getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    public String getUserId() {
        return userId;
    }

    public String getCardType() {
        return cardType;
    }

    public String getMaskedPan() {
        return maskedPan;
    }

    public String getYear() {
        return year;
    }

    public String getMonth() {
        return month;
    }

    public boolean getExpiresSoon() {
        return expiresSoon;
    }

    public String getMerchantId() {
        return merchantId;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(this.id);
        dest.writeString(this.name);
        dest.writeString(this.userId);
        dest.writeString(this.cardType);
        dest.writeString(this.maskedPan);
        dest.writeString(this.year);
        dest.writeString(this.month);
        dest.writeString(this.merchantId);
        dest.writeByte(this.expiresSoon ? (byte) 1 : (byte) 0);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        PaymentMethod that = (PaymentMethod) o;

        if (expiresSoon != that.expiresSoon) return false;
        if (id != null ? !id.equals(that.id) : that.id != null) return false;
        if (name != null ? !name.equals(that.name) : that.name != null) return false;
        if (userId != null ? !userId.equals(that.userId) : that.userId != null) return false;
        if (cardType != null ? !cardType.equals(that.cardType) : that.cardType != null)
            return false;
        if (maskedPan != null ? !maskedPan.equals(that.maskedPan) : that.maskedPan != null)
            return false;
        if (year != null ? !year.equals(that.year) : that.year != null) return false;
        if (month != null ? !month.equals(that.month) : that.month != null) return false;
        return merchantId != null ? merchantId.equals(that.merchantId) : that.merchantId == null;
    }

    @Override
    public int hashCode() {
        int result = id != null ? id.hashCode() : 0;
        result = 31 * result + (name != null ? name.hashCode() : 0);
        result = 31 * result + (userId != null ? userId.hashCode() : 0);
        result = 31 * result + (cardType != null ? cardType.hashCode() : 0);
        result = 31 * result + (maskedPan != null ? maskedPan.hashCode() : 0);
        result = 31 * result + (year != null ? year.hashCode() : 0);
        result = 31 * result + (month != null ? month.hashCode() : 0);
        result = 31 * result + (expiresSoon ? 1 : 0);
        result = 31 * result + (merchantId != null ? merchantId.hashCode() : 0);
        return result;
    }

    public PaymentMethod() {
    }

    @Override
    public String toString() {
        return "PaymentMethod{" + "id='" + id + '\'' +
                ", name='" + name + '\'' +
                ", userId='" + userId + '\'' +
                ", cardType='" + cardType + '\'' +
                ", maskedPan='" + maskedPan + '\'' +
                ", year='" + year + '\'' +
                ", month='" + month + '\'' +
                ", expiresSoon=" + expiresSoon +
                ", merchantId='" + merchantId + '\'' +
                '}';
    }

    protected PaymentMethod(Parcel in) {
        this.id = in.readString();
        this.name = in.readString();
        this.userId = in.readString();
        this.cardType = in.readString();
        this.maskedPan = in.readString();
        this.year = in.readString();
        this.month = in.readString();
        this.merchantId = in.readString();
        this.expiresSoon = in.readByte() != 0;
    }

    public static final Parcelable.Creator<PaymentMethod> CREATOR = new Parcelable.Creator<PaymentMethod>() {
        @Override
        public PaymentMethod createFromParcel(Parcel source) {
            return new PaymentMethod(source);
        }

        @Override
        public PaymentMethod[] newArray(int size) {
            return new PaymentMethod[size];
        }
    };
}
