
package hr.webtech.pay2.data;

import android.os.Parcel;
import android.os.Parcelable;

import com.google.gson.annotations.Expose;
import com.google.gson.annotations.SerializedName;


/**
 * ShowOrderResponse
 * <p>
 * ShowOrderResponse
 *
 * Check <a href='https://gist.github.com/jasminsuljic/400af4c37a3473b9e2894e0084c2ddf2'> json schema</a>
 */
public final class ShowOrderResponse implements Parcelable {

    /**
     * (Required)
     */
    @SerializedName("masked_pan")
    @Expose
    private String maskedPan;
    /**
     * (Required)
     */
    @SerializedName("cc_type")
    @Expose
    private String ccType;
    /**
     * (Required)
     */
    @SerializedName("eci")
    @Expose
    private String eci;
    /**
     * (Required)
     */
    @SerializedName("enrolled")
    @Expose
    private String enrolled;
    @SerializedName("pares_status")
    @Expose
    private String paresStatus;
    /**
     * (Required)
     */
    @SerializedName("amount")
    @Expose
    private long amount;
    /**
     * (Required)
     */
    @SerializedName("currency")
    @Expose
    private String currency;
    /**
     * (Required)
     */
    @SerializedName("exchange_rate")
    @Expose
    private double exchangeRate;
    @SerializedName("number_of_installments")
    @Expose
    private long numberOfInstallments;
    /**
     * (Required)
     */
    @SerializedName("outgoing_amount")
    @Expose
    private long outgoingAmount;
    /**
     * (Required)
     */
    @SerializedName("outgoing_currency")
    @Expose
    private String outgoingCurrency;
    /**
     * (Required)
     */
    @SerializedName("approval_code")
    @Expose
    private String approvalCode;
    /**
     * (Required)
     */
    @SerializedName("reference_number")
    @Expose
    private String referenceNumber;
    /**
     * (Required)
     */
    @SerializedName("response_code")
    @Expose
    private String responseCode;
    /**
     * (Required)
     */
    @SerializedName("acq_response_code")
    @Expose
    private String acqResponseCode;
    /**
     * (Required)
     */
    @SerializedName("status")
    @Expose
    private String status;
    /**
     * (Required)
     */
    @SerializedName("acquirer")
    @Expose
    private String acquirer;
    /**
     * (Required)
     */
    @SerializedName("created_at")
    @Expose
    private String createdAt;

    private ShowOrderResponse(Parcel in) {
        maskedPan = in.readString();
        ccType = in.readString();
        eci = in.readString();
        enrolled = in.readString();
        paresStatus = in.readString();
        amount = in.readLong();
        currency = in.readString();
        exchangeRate = in.readDouble();
        numberOfInstallments = in.readLong();
        outgoingAmount = in.readLong();
        outgoingCurrency = in.readString();
        approvalCode = in.readString();
        referenceNumber = in.readString();
        responseCode = in.readString();
        acqResponseCode = in.readString();
        status = in.readString();
        acquirer = in.readString();
        createdAt = in.readString();
    }

    public static final Creator<ShowOrderResponse> CREATOR = new Creator<ShowOrderResponse>() {
        @Override
        public ShowOrderResponse createFromParcel(Parcel in) {
            return new ShowOrderResponse(in);
        }

        @Override
        public ShowOrderResponse[] newArray(int size) {
            return new ShowOrderResponse[size];
        }
    };

    /**
     * (Required)
     */
    public String getMaskedPan() {
        return maskedPan;
    }

    /**
     * (Required)
     */
    public String getCcType() {
        return ccType;
    }

    /**
     * (Required)
     */
    public String getEci() {
        return eci;
    }

    /**
     * (Required)
     */
    public String getEnrolled() {
        return enrolled;
    }

    public String getParesStatus() {
        return paresStatus;
    }

    /**
     * (Required)
     */
    public long getAmount() {
        return amount;
    }

    /**
     * (Required)
     */
    public String getCurrency() {
        return currency;
    }

    /**
     * (Required)
     */
    public double getExchangeRate() {
        return exchangeRate;
    }

    public long getNumberOfInstallments() {
        return numberOfInstallments;
    }

    /**
     * (Required)
     */
    public long getOutgoingAmount() {
        return outgoingAmount;
    }

    /**
     * (Required)
     */
    public String getOutgoingCurrency() {
        return outgoingCurrency;
    }

    /**
     * (Required)
     */
    public String getApprovalCode() {
        return approvalCode;
    }

    /**
     * (Required)
     */
    public String getReferenceNumber() {
        return referenceNumber;
    }

    /**
     * (Required)
     */
    public String getResponseCode() {
        return responseCode;
    }

    /**
     * (Required)
     */
    public String getAcqResponseCode() {
        return acqResponseCode;
    }

    /**
     * (Required)
     */
    public String getStatus() {
        return status;
    }

    /**
     * (Required)
     */
    public String getAcquirer() {
        return acquirer;
    }

    /**
     * (Required)
     */
    public String getCreatedAt() {
        return createdAt;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeString(maskedPan);
        parcel.writeString(ccType);
        parcel.writeString(eci);
        parcel.writeString(enrolled);
        parcel.writeString(paresStatus);
        parcel.writeLong(amount);
        parcel.writeString(currency);
        parcel.writeDouble(exchangeRate);
        parcel.writeLong(numberOfInstallments);
        parcel.writeLong(outgoingAmount);
        parcel.writeString(outgoingCurrency);
        parcel.writeString(approvalCode);
        parcel.writeString(referenceNumber);
        parcel.writeString(responseCode);
        parcel.writeString(acqResponseCode);
        parcel.writeString(status);
        parcel.writeString(acquirer);
        parcel.writeString(createdAt);
    }
}