package hr.webtech.pay2.data;

import android.os.Parcel;
import android.os.Parcelable;

import com.google.gson.annotations.Expose;
import com.google.gson.annotations.SerializedName;

/**
 * Created by jasminsuljic on 20/12/16.
 * pgw-android
 */
public final class Transaction implements Parcelable {
    @Expose
    @SerializedName("id")
    private int id;

    @Expose
    @SerializedName("response_code")
    private String responseCode;

    @Expose
    @SerializedName("approval_code")
    private String approvalCode;

    @Expose
    @SerializedName("status")
    private String status;

    private Transaction(Parcel in) {
        id = in.readInt();
        responseCode = in.readString();
        approvalCode = in.readString();
        status = in.readString();
    }

    public static final Creator<Transaction> CREATOR = new Creator<Transaction>() {
        @Override
        public Transaction createFromParcel(Parcel in) {
            return new Transaction(in);
        }

        @Override
        public Transaction[] newArray(int size) {
            return new Transaction[size];
        }
    };

    public String getApprovalCode() {
        return approvalCode;
    }

    public int getId() {
        return id;
    }

    public String getResponseCode() {
        return responseCode;
    }

    public String getStatus() {
        return status;
    }

    @Override
    public String toString() {
        return "Transaction{" + "approvalCode='" + approvalCode + '\'' +
                ", id=" + id +
                ", responseCode='" + responseCode + '\'' +
                ", status='" + status + '\'' +
                '}';
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeInt(id);
        parcel.writeString(responseCode);
        parcel.writeString(approvalCode);
        parcel.writeString(status);
    }
}
