package hr.webtech.pay2.util;

import android.support.annotation.Nullable;
import android.util.Base64;

import com.google.gson.Gson;

/**
 * Created by jasminsuljic on 19/12/16.
 * pgw-android
 */

public final class Base64Resolver implements InputResolver {

    private final Gson gson;

    public Base64Resolver(Gson gson) {
        this.gson = gson;
    }

    @Override
    public <T> String encode(@Nullable T data) {
        if (data == null) {
            return null;
        }
        return Base64.encodeToString(gson.toJson(data).getBytes(), Base64.NO_WRAP | Base64.URL_SAFE);
    }

    @Override
    public String decode(@Nullable String input) {

        if (input == null) {
            return null;
        }

        return new String(Base64.decode(input, Base64.NO_WRAP | Base64.URL_SAFE));
    }
}
