package hr.webtech.pay2.data;

import com.google.gson.Gson;

import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by jasminsuljic on 01/08/2018.
 * pgw-android
 */
public class PaymentMethodResponseTest {

    Gson gson = new Gson();

    String firstJsonPaymentMethod = "{\n" +
            "            \"id\": \"4FEjlZ_EOOMMjcKQsyLotY_k_tj2iGiIwN6A1sLS\",\n" +
            "            \"name\": \"John Smith\",\n" +
            "            \"user_id\": \"test@test.com\",\n" +
            "            \"card_type\": \"visa\",\n" +
            "            \"masked_pan\": \"***-4242\",\n" +
            "            \"year\": \"2021\",\n" +
            "            \"month\": \"10\",\n" +
            "            \"expires_soon\": false\n" +
            "        }";

    String secondJsonPaymentMethod = "{\n" +
            "            \"id\": \"RlElTZXGJg8WOOGf8QPcxbTGe8QUBzm0TNqro3qD\",\n" +
            "            \"name\": \"John Smith\",\n" +
            "            \"user_id\": \"test@test.com\",\n" +
            "            \"card_type\": \"visa\",\n" +
            "            \"masked_pan\": \"***-7434\",\n" +
            "            \"year\": \"2021\",\n" +
            "            \"month\": \"10\",\n" +
            "            \"expires_soon\": false\n" +
            "        }";

    PaymentMethod fromJson(String json) {
        return gson.fromJson(json, PaymentMethod.class);
    }

    @Test
    public void getPaymentMethods() {
        String json = String.format("{\n" +
                "    \"payment_methods\": [\n" +
                "        %s,\n" +
                "        %s\n" +
                "    ]\n" +
                "}", firstJsonPaymentMethod, secondJsonPaymentMethod);

        List<PaymentMethod> paymentMethods = new ArrayList<>();

        paymentMethods.add(fromJson(firstJsonPaymentMethod));
        paymentMethods.add(fromJson(secondJsonPaymentMethod));

        Gson gson = new Gson();

        final PaymentMethodResponse paymentMethodResponse = gson.fromJson(json, PaymentMethodResponse.class);

        Assert.assertNotNull(paymentMethodResponse);

        Assert.assertEquals(paymentMethods, paymentMethodResponse.getPaymentMethods());
    }
}